import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

RaceTrack = class();

function RaceTrack:Constructor(size, margin)
	self.size = size;
	self.margin = margin;
	self:clear();
end

function RaceTrack:place(y, lane)
	local i;

	if lane == nil then
		for i = 0, self.lanes - 1, 1 do
			if self.track[i] >= y then
				lane = i;
				break;
			end
		end
	end

	if lane == nil or lane >= self.lanes then
		lane = self.lanes;
		self.lanes = self.lanes + 1;
	end
	self.track[lane] = y - self.size - self.margin;
	return lane;
end

function RaceTrack:find(y, pref)
	local i, r, b, s;

	r = -1;
	b = 0;
	for i = 0, self.lanes - 1, 1 do
		if self.track[i] >= y then
			if pref == nil then
				r = i;
				b = 0;
				break;
			end

			s = pref[i];
			if s == nil then
				s = pref[pref.max] / math.pow(2.0, math.abs(i - pref.max))
			end

			if r == -1 or s > b then
				r = i;
				b = s;
			end
		end
	end

	if r == -1 then
		r = self.lanes;
		if pref ~= nil then
			b = pref[r];
			if b == nil then
				b = pref[pref.max] / math.pow(2.0, math.abs(r - pref.max))
			end
		else
			b = 0;
		end
	end
	return r, b;
end

function RaceTrack:clear()
	self.lanes = 0;
	self.track = { };
end

function RaceTrack:set(lanes)
	self.lanes = lanes;
	self.track = { };

	for i = 0, self.lanes - 1, 1 do
		self.track[i] = math.huge;
	end
end
